#include "StdAfx.h"
#include "LanuageActorEvent.h"

CLanuageActorEvent::CLanuageActorEvent(void)
{
	//g_pMessengerActor->RegisterObserver(this);
	IGTWASActor *pWASActor = g_pMessengerActor->GetWASActor();
	pWASActor->RegisterObserver(this);

	m_tridListSetLang.clear();
	m_tridListGetLang.clear();
}

CLanuageActorEvent::~CLanuageActorEvent(void)
{
	g_pMessengerActor->GetWASActor()->UnRegisterObserver(this);	
	//g_pMessengerActor->UnRegisterObserver(this);
}

bool CLanuageActorEvent::OnGTWASActor_ResponseGetLanguage( IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const NE_LANG_DATA &langData )
{
	//   trid  ƴϸ true Ͽ   óϵ ش.
	std::list<trid_t>::iterator findTrid = std::find(m_tridListGetLang.begin(), m_tridListGetLang.end(), trid);
	if (findTrid == m_tridListGetLang.end())
		return true;

	if (eErrorCode != wasError_None)
	{
		findTrid = std::find(m_tridListGetLang.begin(), m_tridListGetLang.end(), trid);
		if (findTrid != m_tridListGetLang.end())
			m_tridListGetLang.remove(*findTrid);
		return false;
	}

	m_tridListGetLang.remove(*findTrid);
	return false;
}



bool CLanuageActorEvent::RequestSetLanguage( CString strLang )
{
	IGTWASActor *pWASActor = g_pMessengerActor->GetWASActor();
	trid_t trid;

	if (pWASActor->RequestSetLanguage(strLang))
	{
		m_tridListSetLang.push_back(trid);
		return true;
	}
	else
	{
		ASSERT(FALSE);
		return false;
	}

}


bool CLanuageActorEvent::RequestGetLanguage()
{
	IGTWASActor *pWASActor = g_pMessengerActor->GetWASActor();
	trid_t trid;

	if (pWASActor->RequestGetLanguage())
	{
		m_tridListGetLang.push_back(trid);
		return true;
	}
	else
	{
		ASSERT(FALSE);
		return false;
	}
}
bool CLanuageActorEvent::OnGTWASActor_ResponseSetLanguage( IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const NE_LANG_DATA &langData )
{
	//   trid  ƴϸ true Ͽ   óϵ ش.
	std::list<trid_t>::iterator findTrid = std::find(m_tridListSetLang.begin(), m_tridListSetLang.end(), trid);
	if (findTrid == m_tridListSetLang.end())
    {
		return true;
    }

	if (eErrorCode != wasError_None)
	{
		findTrid = std::find(m_tridListGetLang.begin(), m_tridListGetLang.end(), trid);
		if (findTrid != m_tridListGetLang.end())
			m_tridListGetLang.remove(*findTrid);
		return false;
	}

	m_tridListSetLang.remove(*findTrid);
	return false;
}